Update package description and documentation to reflect squeeze as current stable...
[grml-debootstrap.git] / grml-debootstrap
index 8cafe54..5b426dc 100755 (executable)
@@ -1,9 +1,9 @@
-#!/bin/sh
-# Filename:      grml-bootstrap
-# Purpose:       wrapper around debootstrap for installing plain Debian via grml
+#!/bin/bash
+# Filename:      grml-debootstrap
+# Purpose:       wrapper around debootstrap for installing plain Debian via Grml
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
-# License:       This file is licensed under the GPL v2.
+# License:       This file is licensed under the GPL v2+
 ################################################################################
 # http://www.debian.org/releases/stable/i386/index.html.en
 
@@ -11,7 +11,8 @@ set -e # exit on any error
 
 # variables {{{
 PN="$(basename $0)"
-VERSION='0.28'
+VERSION="$(dpkg --list $PN 2>/dev/null| awk '/^i/ {print $3}')"
+VERSION="${VERSION:-unknown}"
 MNTPOINT="/mnt/debootstrap.$$"
 
 # inside the chroot system locales might not be available, so use minimum:
@@ -39,7 +40,7 @@ Bootstrap options:
   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
                            instead of fetching packages from a mirror.
-  -r, --release <name>   Release of new Debian system (default: lenny).
+  -r, --release <name>   Release of new Debian system (default: squeeze).
   -t, --target <target>  Target partition (/dev/...) or directory where the
                          system should be installed to.
   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
@@ -47,10 +48,10 @@ Bootstrap options:
       --debopt <params>  Extra parameters passed to the debootstrap command.
       --interactive      Use interactive mode (frontend).
       --nodebootstrap    Skip debootstrap, only do configuration to the target.
-      --groot <device>   Root device for usage in grub, corresponds with
-                           \$TARGET in grub syntax, like hd0,0 for /dev/sda1.
-      --grub <device>    Target for grub installation. Use grub syntax for
-                           specifying, like hd0 for /dev/sda.
+      --grub <device>    Target for grub installation. Usage example: /dev/sda
+      --arch <arch>      Architecture to use. Currently only i386 is supported.
+      --filesystem <fs>  Filesystem that should be used when target is a partition.
+      --insecure         Do not download and check Release file signatures.
 
 Configuration options:
 
@@ -59,13 +60,16 @@ Configuration options:
   -d, --confdir <path>     Place of config files for debootstrap, defaults
                              to /etc/debootstrap
       --packages <file>    Install packages defined in specified list file.
+      --nopackages         Skip installation of packages defined in
+                             /etc/debootstrap/packages
       --debconf <file>     Pre-seed packages using specified pre-seed db file.
       --keep_src_list      Do not overwrite user provided apt sources.list.
       --hostname <name>    Hostname of Debian system.
       --password <pwd>     Use specified password as password for user root.
       --bootappend <line>  Add specified appendline to kernel whilst booting.
       --chroot-scripts <d> Execute chroot scripts from specified directory.
-      --scripts <dir>      Execute scripts from specified directory.
+      --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
+      --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
 
 Other options:
 
@@ -78,7 +82,7 @@ Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
 "
 }
 
-if [ "$1" = '-h' ] || [ "$1" = '-help' ] ; then
+if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
    usage
    echo 'Please notice that this script requires root permissions!'
    exit 0
@@ -87,28 +91,20 @@ fi
 
 # make sure we have what we need {{{
 check4progs debootstrap dialog || exit 1
-check4root || exit 1
 # }}}
 
-# source configuration file {{{
+# source main configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
-   if [ -n "$CONFIGFILE" ] ; then
-      einfo "Using config file $CONFIGFILE."
-      if ! . "$CONFIGFILE" ; then
-         eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
-      fi
-   else
-      . /etc/debootstrap/config
-   fi
+  . /etc/debootstrap/config
 fi
 # }}}
 
 # cmdline handling {{{
 # source external command line parameter-processing script
-if [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
-   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
-elif [ -r ./cmdlineopts.clp ] ; then
+if [ -r ./cmdlineopts.clp ] ; then
    . ./cmdlineopts.clp
+elif [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
+   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
 else
    echo "Error: cmdline function file not found, exiting.">&2
    exit 1
@@ -139,16 +135,20 @@ fi
 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
 [ "$_opt_interactive" ]         && INTERACTIVE=1
 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
+[ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
 [ "$_opt_packages_set" ]        && PACKAGES='yes'
+[ "$_opt_nopackages" ]          && PACKAGES=''
 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
 [ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
-[ "$_opt_groot" ]               && GROOT=$_opt_groot
 [ "$_opt_grub" ]                && GRUB=$_opt_grub
+[ "$_opt_arch" ]                && ARCH=$_opt_arch
+[ "$_opt_insecure" ]            && SECURE='false'
 [ "$_opt_verbose" ]             && VERBOSE="-v"
 
 [ "$_opt_help" ] && {
@@ -165,6 +165,37 @@ fi
 }
 # }}}
 
+# check for root permissions {{{
+if ! check4root ; then
+   echo "For usage instructions please execute '$PN --help'."
+   exit 1
+fi
+# }}}
+
+# source specified configuration file {{{
+if [ -n "$CONFIGFILE" ] ; then
+   einfo "Reading specified config file $CONFIGFILE."
+   if ! . "$CONFIGFILE" ; then
+      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
+   fi
+fi
+# }}}
+
+# backwards compability checks {{{
+if [ -n "$GROOT" ] ; then
+   echo "Error: you seem to have \$GROOT configured." >&2
+   echo "This variable is no longer supported, please visit the" >&2
+   echo "grml-debootstrap documentation for details." >&2
+   exit 1
+fi
+
+if echo "$GRUB" | grep -q '^hd' ; then
+   echo "Error: this syntax for the grub configuration variable is no longer supported." >&2
+   echo "Please do not use hd... any longer but /dev/sdX instead." >&2
+   exit 1
+fi
+# }}}
+
 # welcome screen {{{
 welcome_dialog()
 {
@@ -190,7 +221,7 @@ prompt_for_target()
   fi
 
   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                       echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
+                       echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet])"
                    done)
 
   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
@@ -220,7 +251,7 @@ prompt_for_bootmanager()
         MBRDISK=$(readlink -f $MBRDISK)
      else
         # fall back to old behaviour
-        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$/')
+        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$//')
      fi
 
      MBRPART="MBR of $MBRDISK"
@@ -239,7 +270,6 @@ prompt_for_bootmanager()
   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
             mbr       "install bootmanager into $MBRPART" \
-            partition "install bootmanager into partition $TARGET" \
             nowhere   "do not install bootmanager at all" \
           ${ADDITIONAL_PARAMS})
   [ $? -eq 0 ] || bailout 3
@@ -249,22 +279,24 @@ prompt_for_bootmanager()
     mbr)
       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
       if echo "$TARGET" | grep -q "/dev/md" ; then
-         BOOT_PARTITION="$TARGET"
+         # using sw-raid:
+         if [ -n "$SELECTED_PARTITIONS" ] ; then
+            GRUB=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
+         else
+            GRUB="$TARGET"
+         fi
       else
-         BOOT_PARTITION="$MBRDISK"
+        GRUB="$MBRDISK"
       fi
       ;;
-    partition)
-      BOOT_PARTITION="$TARGET"
-      ;;
     hda)
-      BOOT_PARTITION="/dev/hda"
+      GRUB="/dev/hda"
       ;;
     sda)
-      BOOT_PARTITION="/dev/sda"
+      GRUB="/dev/sda"
       ;;
     nowhere)
-      BOOT_PARTITION=''
+      GRUB=''
       ;;
   esac
 }
@@ -273,13 +305,13 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='lenny'
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='squeeze'
   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
             0 50 4 \
-            etch     Debian/old-stable \
-            lenny    Debian/stable \
-            squeeze  Debian/testing \
+            lenny    Debian/old-stable \
+            squeeze  Debian/stable \
+            wheezy   Debian/testing \
             sid      Debian/unstable)"
 }
 # }}}
@@ -326,11 +358,11 @@ prompt_for_mirror()
           )
 
   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
-     [ -n "$MIRROR" ] || MIRROR='ftp://ftp.de.debian.org/debian'
+     [ -n "$MIRROR" ] || MIRROR='http://cdn.debian.net/debian'
      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter Debian mirror you would like to use for installing packages." \
                0 0 $MIRROR)"
-  else # CHROOT_VARIABLES == local
+  else # CHOOSE_MIRROR == local
      [ -n "$ISO" ] || ISO='/mnt/mirror'
      ISO="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter directory name you would like to use for installing packages." \
@@ -339,45 +371,6 @@ prompt_for_mirror()
 }
 # }}}
 
-# get grub's syntax for /dev/ice {{{
-# usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
-grubdevice() {
-  if [ -z "$1" ] ; then
-     echo "Usage: grubdevice <device>">&2
-     return 1
-  fi
-
-  device="$1"
-  device_map=/boot/grub/device.map
-
-  # create device.map
-  if ! [ -f "$device_map" ] ; then
-     echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
-  fi
-
-  # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
-  tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
-                    -e 's%\(fd[0-9]*\)$%\1%' \
-                    -e 's%/part[0-9]*$%/disc%' \
-                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
-  tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
-                    -e 's%.*/fd[0-9]*$%%' \
-                    -e 's%.*/floppy/[0-9]*$%%' \
-                    -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
-                    -e 's%.*c[0-7]d[0-9]*p*%%'`
-  tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
-
-  case $1 in
-     /dev/[sh]d[a-z]) # we expect something like 'hd0'
-        echo "$tmp_drive"
-        ;;
-      *) # we expect something like 'hd0,0'
-        echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
-        ;;
-  esac
-}
-# }}}
-
 # software raid setup {{{
 config_swraid_setup()
 {
@@ -410,7 +403,7 @@ AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
 [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
 PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
-                     echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
+                     echo "$i $(blkid -s TYPE -o value $i 2>/dev/null || echo [no_filesystem_yet]) off"
                  done)
 
 dialog --title "$PN" --separate-output \
@@ -424,11 +417,17 @@ for i in $(cat $TMPFILE) ; do
    NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
 done
 
+# force metadata version 0.90 for lenny so old grub can boot from this array.
+METADATA_VERSION=""
+if [ $RELEASE = "lenny" ]; then
+   METADATA_VERSION="-e0"
+fi
+
 ERRORFILE=$(mktemp)
 set +e
 # TODO: better error handling?
 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
-      --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} 1>/dev/null 2>$ERRORFILE
+      --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
 RC=$?
 set -e
 
@@ -537,33 +536,18 @@ interactive_mode()
 {
   welcome_dialog
 
+  prompt_for_release
+
   prompt_for_swraid
 
   prompt_for_target
 
   prompt_for_bootmanager
 
-  prompt_for_release
-
   prompt_for_hostname
 
   prompt_for_password
 
-  # use first disk of sw-raid for grub by default, install grub on
-  # all involved disks later on
-  if echo "$TARGET" | grep -q '/dev/md' ; then
-     if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
-        # use hdX and not hdX,Y for $GRUB
-        TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
-        GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
-        GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
-        echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
-     fi
-  else
-     [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
-     [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
-  fi
-
   prompt_for_mirror
 }
 
@@ -605,11 +589,7 @@ fi
 PARTITION=''
 DIRECTORY=''
 
-case $TARGET in
-  /dev/*)
-    PARTITION=1
-    ;;
-  *)
+set_target_directory(){
     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
     DIRECTORY=1
     MNTPOINT="$TARGET"
@@ -617,9 +597,17 @@ case $TARGET in
     TUNE2FS=''
     FSCK=''
     GRUB=''
-    GROOT=''
-    ;;
-esac
+    # make sure we normalise the path to an absolute directory name so something like:
+    #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
+    # works
+    TARGET="$(readlink -f $TARGET)"
+}
+
+if [ -b "$TARGET" ] ; then
+    PARTITION=1
+else
+    set_target_directory
+fi
 # }}}
 
 # architecture setup {{{
@@ -633,6 +621,19 @@ else
 fi
 # }}}
 
+# keyring setupt {{{
+KEYRING=""
+if [ "$SECURE" = 'yes' ] ; then
+   if [ -e '/etc/apt/trusted.gpg' ] ; then
+      KEYRING="--keyring /etc/apt/trusted.gpg"
+   else
+      eerror "Could not find /etc/apt/trusted.gpg."
+   fi
+else
+   ewarn "Not checking Release signatures!"
+fi
+# }}}
+
 # make sure we have the right syntax when using an iso image {{{
 if [ -n "$ISO" ] ; then
    case $ISO in
@@ -656,17 +657,18 @@ bailout(){
         # make sure nothing is left inside chroot so we can unmount it
         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
-        # ugly, but make sure we really don't leav anything
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
-        [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
+        # ugly, but make sure we really don't leave anything (/proc /proc is intended)
+        for ARG in /sys /proc /proc ; do
+          [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
+        done
+        umount "$MNTPOINT"/dev >/dev/null 2>&1 || true
+
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
 
         if [ -n "$DIRECTORY" ] ; then
           einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
         else
-          einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+          einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
         fi
 
         if [ -n "$STAGES" ] ; then
@@ -715,9 +717,23 @@ mkfs() {
 
     if [ -n "$MKFS" ] ; then
        einfo "Running $MKFS on $TARGET"
-       $MKFS $TARGET
-       TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
-       eend $?
+       $MKFS $TARGET ; RC=$?
+
+       # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
+       # will fail to detect the uuid in the chroot
+       if echo "$TARGET" | grep -q "/dev/md" ; then
+         blockdev --rereadpt "${TARGET}"
+       else
+         blockdev --rereadpt "${TARGET%%[0-9]*}"
+       fi
+       # give the system 2 seconds, otherwise we might run into
+       # race conditions :-/
+       sleep 2
+
+       eval $(blkid -o udev $TARGET 2>/dev/null)
+       [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
+
+       eend $RC
     fi
 
   fi
@@ -726,7 +742,7 @@ mkfs() {
 
 # modify filesystem settings {{{
 tunefs() {
-  if [ -n "$TUNE2FS" ] ; then
+  if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
      $TUNE2FS $TARGET
      eend $?
@@ -759,17 +775,20 @@ mount_target() {
 
 # install main chroot {{{
 debootstrap_system() {
-  if ! grep -q "$MNTPOINT" /proc/mounts ; then
-     mount_target
-  fi
   if [ "$_opt_nodebootstrap" ]; then
      einfo "Skipping debootstrap as requested."
      return
   fi
+
   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
      einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR || \
-     $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+     if [ -n "$MIRROR" ] ; then
+        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
+        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
+     else
+        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
+        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+     fi
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -787,18 +806,20 @@ preparechroot() {
   touch $CHROOT_VARIABLES
   chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
   echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
-  [ -n "$ARCH" ]         && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
-  [ -n "$GROOT" ]        && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
-  [ -n "$GRUB" ]         && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
-  [ -n "$HOSTNAME" ]     && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
-  [ -n "$ISODIR" ]       && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
-  [ -n "$ISO" ]          && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]       && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$ARCH" ]          && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]          && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]      && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
+  [ -n "$INSTALL_NOTES" ] && echo "INSTALL_NOTES=$INSTALL_NOTES" >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]        && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]           && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
   [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
-  [ -n "$PACKAGES" ]     && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
-  [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-  [ -n "$TARGET" ]       && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
-  [ -n "$TARGET_UUID" ]  && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]        && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]      && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
+  [ -n "$RM_APTCACHE" ]   && echo "RM_APTCACHE=$RM_APTCACHE"   >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ]  && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
+  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=$SELECTED_PARTITIONS" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]        && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]   && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
 
   cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
@@ -810,7 +831,11 @@ preparechroot() {
   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
-  sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
+
+  # install notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" $MNTPOINT/etc/debootstrap/
+  fi
 
   # package selection:
   cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
@@ -862,10 +887,31 @@ preparechroot() {
      cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
   fi
 
+  # install config file providing some example entries
+  if [ -r /etc/network/interfaces.examples -a ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
+     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
+  fi
+
   eend 0
 }
 # }}}
 
+# execute all scripts in /etc/debootstrap/pre-scripts/ {{{
+execute_pre_scripts() {
+   # make sure we have $MNTPOINT available for our scripts
+   export MNTPOINT
+   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
+      [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="$CONFFILES/pre-scripts/"
+      for script in ${pre_scripts}/* ; do
+         if [ -x "$script" ] ; then
+            einfo "Executing pre-script $script"
+            $script ; eend $?
+         fi
+      done
+   fi
+}
+# }}}
+
 # execute all scripts in /etc/debootstrap/scripts/ {{{
 execute_scripts() {
    # make sure we have $MNTPOINT available for our scripts
@@ -887,10 +933,13 @@ chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
      mount_target
   fi
+
   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
      einfo "Executing chroot-script now"
-     chroot "$MNTPOINT" /bin/chroot-script
-     eend $?
+     mount --bind /dev "$MNTPOINT"/dev
+     chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
+     umount "$MNTPOINT"/dev
+     eend $RC
   else
      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
      eend 1
@@ -898,33 +947,14 @@ chrootscript() {
 }
 # }}}
 
-# install booloader grub {{{
-grub_install() {
-  if [ -z "$GRUB" -o -z "$GROOT" ] ; then
-     echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
-  elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
-     for device in $SELECTED_PARTITIONS ; do
-        # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
-        # GRUB="$(grubdevice ${TMPDEVICE})"
-        # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
-        # GRUB=$(grubdevice $device)
-        GRUB="$(grubdevice ${device%%[0-9]})"
-        einfo "Installing grub on ${GRUB}:"
-        [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-        $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
-        eend $?
-     done
-  else
-     einfo "Installing grub on ${GRUB}:"
-     [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
-     $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
-     eend $?
+# unmount $MNTPOINT {{{
+umount_chroot() {
+
+  # display installation notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
   fi
-}
-# }}}
 
-# unmount $MNTPOINRT {{{
-umount_chroot() {
   if [ -n "$ISODIR" ] ; then
      if grep -q "$ISODIR" /proc/mounts ; then
         einfo "Unmount $MNTPOINT/$ISODIR"
@@ -956,7 +986,7 @@ fscktool() {
 
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
-         chrootscript execute_scripts grub_install umount_chroot   \
+         execute_pre_scripts chrootscript execute_scripts umount_chroot   \
          fscktool ; do
     if stage "${i}" ; then
        $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
@@ -976,8 +1006,12 @@ fi
 
 # end dialog of autoinstallation {{{
 if [ -n "$AUTOINSTALL" ] ; then
-   dialog --title "$PN" --msgbox \
-          "Finished execution of ${PN}. Enjoy your Debian system." 0 0
+   if dialog --title "${PN}" --pause "Finished execution of ${PN}.
+Automatically rebooting in 10 seconds.
+
+Choose Cancel to skip rebooting." 10 60 10 ; then
+     noeject noprompt reboot
+  fi
 else
    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
 fi